#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <set>
#include <map>
#include <algorithm>
#define DEBUG
using namespace std;


void fast_io(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	#ifdef DEBUG
		freopen("c.in", "r", stdin);
		freopen("c.out", "w", stdout);
	#endif
}

const int N = 2e5;

int t[N*4];
int cnt[N*4];

void push(int v, int l, int r){
	if(cnt[v]!=0){
		t[v] += cnt[v]*(r-l+1);
		if(l!=r){
			cnt[v*2] = cnt[v];
			cnt[v*2+1] = cnt[v];
		}
		cnt[v] = 0;
	}
}

void update(int v, int l, int r, int ql, int qr, int k){
	push(v, l, r);
	if(ql<=l && r<=qr){
		cnt[v] += k;
	} else if(l>qr || ql>r){
		return;
	} else{
		int mid = l+(r-l)/2;
		update(v*2, l, mid, ql, qr, k);
		update(v*2+1, mid+1, r, ql, qr, k);
		t[v] = t[v*2]+t[v*2+1];
	}
}

int get(int v, int l, int r, int k){
	push(v, l, r);
	if(l==r){
		return t[v];
	} else{
		int mid = l+(r-l)/2;
		if(k<=mid){
			return get(v*2, l, mid, k);
		} else{
			return get(v*2+1, mid+1, r, k);
		}
	}
}

signed main(){
	fast_io();
	int n;
	cin >> n;
	vector<int> nums(n);
	for(int i=0; i<n; i++){
		cin >> nums[i];
	}
	if(n<=5000){
		map<int, int> kek;
		int cnt = 0;
		vector<int> lol_type(n);
		for(int i=0; i<n; i++){
			if(kek[nums[i]]==0){
				kek[nums[i]] = ++cnt;
			}
			lol_type[i] = kek[nums[i]];
		}
		for(int i=1; i<=n; i++){
			int ans = 0;
			vector<int> lol(n+1, 0);
			int kek = 0;
			for(int j=0; j<i; j++){
				lol[lol_type[j]]++;
				if(lol[lol_type[j]]==1)
					ans++;
			}
			kek+=ans;
			for(int j=1; j<n-i+1; j++){
				lol[lol_type[j-1]]--;
				if(lol[lol_type[j-1]]==0)
					ans--;
				lol[lol_type[j+i-1]]++;
				if(lol[lol_type[j+i-1]]==1)
					ans++;
				kek+=ans;
			}		
			cout << kek << " ";
		}
	} else{
		cout << n << " ";
		vector<int> kek(51, -1);
		for(int i=0; i<n; i++){
			vector<int> lol;
			lol = kek;
			sort(lol.begin(), lol.end());
			reverse(lol.begin(), lol.end());
			int last = i;
			for(int j=2; j<51; j++){
				if(lol[j]==-1){
					break;
				}
				else{
					int need_to_upd = lol[j]-last;
					update(1, 0, 2e5, last-i+1, lol[j]-i+1, i);
				}
			}
			kek[nums[i]] = i;
		}
		for(int i=2; i<=n; i++){
			cout << get(1, 0, 2e5, i) << " ";
		}
	}
	return 0;
}