#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
}

const int MAXN = 2 * 1e5 + 10;
const ll INF = 1e9 + 10;
const ll MOD = 1e9 + 7;


int n, a[MAXN];
ll ans[MAXN];

void compress(){
	vector <pii> v(n);
	for(int i = 0; i < n; i++)
		v[i] = {a[i], i};
	sort(v.begin(), v.end());
	int last = v[0].f, val = 0;
	for(int i = 0; i < n; i++){
		if(v[i].f > last)
			val++;
		a[v[i].s] = val;
		last = v[i].f;
	}
}

pii boarders[MAXN];

void find_boarders(){
	vector <vi> v;
	v.resize(n);
	for(int i = 0; i < n; i++)
		v[a[i]].pb(i);
	for(int i = 0; i < n; i++){
		int pos = lower_bound(v[a[i]].begin(), v[a[i]].end(), i) - v[a[i]].begin();
		boarders[i].f = (pos - 1 >= 0 ? v[a[i]][pos - 1] : -1);
		boarders[i].s = (pos + 1 < v[a[i]].size() ? v[a[i]][pos + 1] : n);	
	}
}

ll cnt_fulls[MAXN];

ll tree_eq[4 * MAXN];

void upd_eq(int u, int l, int r, int ql, int qr, ll val){
	if(l >= ql && r <= qr){
		tree_eq[u] += val;
		return;
	}
	if(l > qr || r < ql)
		return;
	int mid = (l + r) / 2;
	upd_eq(u * 2 + 1, l, mid, ql, qr, val);
	upd_eq(u * 2 + 2, mid + 1, r, ql, qr, val);
}

ll get_eq(int u, int l, int r, int pos){
	if(l == r)
		return tree_eq[u];
	int mid = (l + r) / 2;
	if(mid >= pos)
		return tree_eq[u] + get_eq(u * 2 + 1, l, mid, pos);
	return tree_eq[u] + get_eq(u * 2 + 2, mid + 1, r, pos);
}

pair <ll, ll> tree_dif[4 * MAXN];

void upd_dif(int u, int l, int r, int ql, int qr, ll val){
	if(l >= ql && r <= qr){
		tree_dif[u].f += val;
		tree_dif[u].s++;
		return;
	}
	if(l > qr || r < ql)
		return;
	int mid = (l + r) / 2;
	upd_dif(u * 2 + 1, l, mid, ql, qr, val);
	if(ql <= mid)
		val -= (mid - max(l, ql) + 1);
	upd_dif(u * 2 + 2, mid + 1, r, ql, qr, val);
}

ll get_dif(int u, int l, int r, int pos){
	if(l == r)
		return tree_dif[u].f;
	int mid = (l + r) / 2;
	ll val = tree_dif[u].f - (ll)(pos - l) * tree_dif[u].s;
	if(mid >= pos)
		return val + get_dif(u * 2 + 1, l, mid, pos);
	return val + get_dif(u * 2 + 2, mid + 1, r, pos);
}



int main(){
	fastIO();
	cin >> n;
	for(int i = 0; i < n; i++)
		cin >> a[i];
	compress();
	find_boarders();	
	for(int i = 0; i < n; i++){
		int l = boarders[i].f, r = n;
		int cnt_full = min(i - l, r - i);
		cnt_fulls[cnt_full]++;
		if(cnt_full + 1 <= max(i - l, r - i)){
		//	cerr << cnt_full + 1 << ' ' << max(i - l, r - i) << endl;
			upd_eq(0, 0, n, cnt_full + 1, max(i - l, r - i), cnt_full);
		}	
		int maxx = max(i - l, r - i);
		if(maxx + 1 <= maxx + cnt_full - 1){
		//	cerr << maxx + 1 << ' ' << maxx + cnt_full - 1 << ' ' << cnt_full - 1 << endl;
			upd_dif(0, 0, n, maxx + 1, maxx + cnt_full - 1, cnt_full - 1);
		}
	}
	for(int i = n; i > 0; i--){
		cnt_fulls[i] += cnt_fulls[i + 1];
		ans[i] += cnt_fulls[i] * (ll)i;	
	}
	for(int i = 1; i <= n; i++)
		ans[i] += get_eq(0, 0, n, i) + get_dif(0, 0, n, i);
	
	for(int i = 1; i <= n; i++)
		cout << ans[i] << ' ';
	



	return 0;
}