#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
}

const int MAXN = 1e5 + 10;
const ll INF = 1e9 + 10;
const ll MOD = 1e9 + 7;

int n, m, s;
vector <vector <pair <pii, int> > > instr;
vector <vi> table;
int num_in_col[MAXN];

void solve1(){
	cout << s;
	exit(0); 
}

void solve2(){
	if(s == 0){
		cout << 0 << ' ' << 0;
		exit(0);
	}
	vi ors, ands;
	for(int i = 0; i < m; i++){
		if(instr[i][0].s == 1)
			ands.pb(table[i][1]);
		else
			ors.pb(table[i][0]);
	}
	sort(ors.begin(), ors.end());
	sort(ands.begin(), ands.end());
	if(ors.size() >= s){
		cout << ors[s - 1] + 1 << ' ' << 0;
		exit(0);
	}
	cout << m << ' ';
	s -= ors.size();
	cout << ands[s - 1] + 1;
	exit(0);
}

void solve3(){
	vi z;
	vector <vector <bool> > new_table;
	new_table.resize(m);	
	for(int mask = 0; mask < pow(3, n); mask++){
		int MASK = mask;
		while(MASK > 0){
			z.pb(MASK % 3);
			MASK /= 3;
		}
		while(z.size() < n)
			z.pb(0);
		for(int i = 0; i < m; i++){
			new_table[i].resize(2 * n - 1);
			for(int j = 0; j < n; j++)
				new_table[i][j] = (table[i][j] < z[j]);
		}
		for(int row = 0; row < m; row++){
			for(int i = 0; i < n - 1; i++){
				int fst = instr[row][i].f.f, snd = instr[row][i].f.s, op = instr[row][i].s; 
				if(op == 1)
					new_table[row][n + i] = new_table[row][fst] & new_table[row][snd];
				else
					new_table[row][n + i] = new_table[row][fst] | new_table[row][snd];	
			}
		}
		int cnt = 0;
		for(int i = 0; i < m; i++)
			cnt += (int)new_table[i][2 * n - 2];
		if(cnt == s){
			for(auto cur : z)
				cout << cur << ' ';
			exit(0);
		}
		z.clear();
		for(int i = 0; i < m; i++)
			new_table[i].clear();
	}
}

bool check4(){
	for(int i = 0; i < m; i++){
		for(int j = 0; j < n; j++){
			if(table[i][j] != i - 1)
				return 0;
		}
	}
	return 1;
}

void solve4(){
	for(int i = 0; i < n; i++)
		cout << s << ' ';
	exit(0);	
}

int main(){
	fastIO();
	cin >> n >> m >> s;
	instr.resize(m);
	for(int i = 0; i < m; i++){
		for(int j = 0; j < n - 1; j++){
			int id1, id2, op;
			cin >> id1 >> id2 >> op;
			instr[i].pb({{id1 - 1, id2 - 1}, op});
		}
	}
	table.resize(m);
	for(int i = 0; i < m; i++){
		table[i].resize(n);
		for(int j = 0; j < n; j++)
			cin >> table[i][j];
	}
	if(n == 1)
		solve1();	
	else if(n == 2)
		solve2();
	else if(n <= 10 && m <= 2)
		solve3();
	else if(check4())
		solve4();



	return 0;
}